clear
close all
addpath /data/mgoes/AX8/Time_transform
addpath /data/mgoes/matlab/timeplt
addpath /data/mgoes/matlab/timeutil
addpath /automount1/mgoes/AX8/Time_transform
addpath /automount1/mgoes/matlab/timeplt
addpath /automount1/mgoes/matlab/timeutil

direc = '../xbt_data_from_GLB_hycom/';

%LOAD LOOKUP
load('../xbt_2009_2015.dat');
lon     = xbt_2009_2015(:,1);
lat     = xbt_2009_2015(:,2);
month   = xbt_2009_2015(:,3);
max_dep = xbt_2009_2015(:,4);
clear xbt_2009_2015
jld = month2julian(num2str(month));

nsections = 24;
number = 1:length(month);
miss = -9999;

clear T S Z X Y
%stop
ZT = [5:5:300 310:10:800 850:50:1000 1100:100:6100]';
%ZT = [0:5:300 310:10:6100]';  %initial
nz = length(ZT);
nlon = floor(length(month)/nsections);%+1;
%nlon = 307;

%T=nan*ones(1000,nsections,floor(length(month)/nsections)); %without interp
T=nan*ones(nz,nlon,nsections);
S=T;U=T;V=T;Z=T;
X = nan*ones(nlon,nsections);
Y = nan*ones(nlon,nsections);
%Z = repmat(ZT,[1,nlon,nsections]);%*ones(nz,nlon,nsections);
count = 0;%1;%0;
j = 1;

%LOAD DATA
for ii=number
num  = sprintf('000%i',ii);
num  = num(end-3:end);
filename = strcat(direc,'data_xbt_',num,'.txt')
data0 = importdata(filename,' ');
header = data0(1,:);
data0 = data0(2:end,:);
%if strcmp(['data_xbt_',num,'.txt'],'data_xbt_0122.txt'),keyboard,end
[l1 l2] = size(data0);
data = nan*ones(l1,5);
data(:,1:l2) = data0; clear data0
data(data == miss) = nan;
lon(ii) = header(1);
lat(ii) = header(2);
day(ii) = header(3);
max_dep(ii) = header(4);
juld(ii) = month2julian(num2str(day));

%nz   = size(data,1);  %without interp
 if (abs(jld(ii)-jld(max(1,ii-1)))>10 | abs(lon(ii)-lon(max(1,ii-1)))>10)
    count = 0;%1;%0;
    j = j+1;
 end
%count = count + 1;
acha = find(~isnan(data(:,1)));

modo = 'find';%'int';

if nnz(acha) > 1  %~isempty(acha)
count = count + 1;

 switch modo
 case 'find'
ZT2 = data(acha,5);[C,IA,IB] = intersect(ZT,ZT2); %ZT2(IB);
nz2 = length(IB);
T(1:nz2,count,j) = data(acha(IB),1);
S(1:nz2,count,j) = data(acha(IB),2);
U(1:nz2,count,j) = data(acha(IB),3);
V(1:nz2,count,j) = data(acha(IB),4);
Z(1:nz,count,j) = ZT;

 case 'interp'
%CHECK IF DEPTH IS FINE. USE ZT AS THE FILE'S DEPTH
%if sum(data(acha,5)-ZT(acha)) ~0;[data(acha,5) ZT(acha)], pause;end

T(1:nz,count,j) = interp1(data(acha,5),data(acha,1),ZT);
S(1:nz,count,j) = interp1(data(acha,5),data(acha,2),ZT);
U(1:nz,count,j) = interp1(data(acha,5),data(acha,3),ZT);
V(1:nz,count,j) = interp1(data(acha,5),data(acha,4),ZT);
Z(1:nz,count,j) = ZT;
 end
%end %nnz(acha)

%without interp
%T(1:nz,count,j) = data(:,1);
%S(1:nz,count,j) = data(:,2);
%U(1:nz,count,j) = data(:,3);
%V(1:nz,count,j) = data(:,4);
%Z(1:nz,count,j) = data(:,5);
%time(count,j) = month2yfraction(num2str(month(ii)));
time(count,j)   = jld(ii);
X(count,j)      = lon(ii);
Y(count,j)      = lat(ii);

%Boundaries for X,Y
%if count == 2
%X(1,j) = X(2,j)-0.2;
%Y(1,j) = Y(2,j);
% if j>1
%   az = find(~isnan(X(:,j-1)));
%   X(countm+1,j-1) = X(countm,j-1)+0.2;
%   Y(countm+1,j-1) = Y(countm,j-1);
%time(countm+1,j-1) = time(countm,j-1);
%T(:,countm+1,j-1) = 0;%T(:,countm,j-1);
%S(:,countm+1,j-1) = 0;%T(:,countm,j-1);
%U(:,countm+1,j-1) = 0;%T(:,countm,j-1);
%V(:,countm+1,j-1) = 0;%T(:,countm,j-1);
%Z(:,countm+1,j-1) = Z(:,countm,j-1);
% end
%end
countm = count;

end %nnz(acha)
end

inan = T==0;
T(inan) = nan;
S(inan) = nan;
U(inan) = nan;
V(inan) = nan;
Z(inan) = nan;
inan = Y==0;
X(inan) = nan;
Y(inan) = nan;


stop
save ../HYCOM/XBT_HYCOM.mat T S U V Z X Y time

%%
costa = load('coast.mat');
for ii=1:size(time,2)
 acha = ~isnan(X(:,ii));
%area = sw_area(X(acha,ii),Y(acha,ii));
%area = sqrt(diag(area));area = ones(nz,1)*area';
 figure(1),clf
axes('position',[.1 .1 .8 .7])
%pcolor(X(acha,ii),Z(:,acha,ii),V(:,acha,ii)) 
pcolor(X(:,ii),Z(:,:,ii),V(:,:,ii)) 
%pcolor(X(:,ii),Z(:,:,ii),T(:,:,ii)) 
%pcolor(X(acha,ii),Z(:,acha,ii),gradient(T(:,acha,ii)).*area) 
shading interp
colormap(jet)
set(gca,'ydir','reverse')
set(gca,'fontname','palatino')
xlim([-60 20])
axes('position',[.1 .82 .8 .1])
%plot(X(acha,ii),Y(acha,ii),'.')
plot(X(:,ii),Y(:,ii),'.')
axis([-60 20 -50 -20])
hold on
plot(costa.long,costa.lat,'.k')
set(gca,'xticklabel',[])
set(gca,'fontname','palatino')
drawnow
%stop
%print('-djpeg','-r300',sprintf('%s%i%s','../figures/XBT_section_',ii,'.jpg'));
pause
end


